#ifndef _VMEchip2_h
#define _VMEchip2_h


#include "VMEchip2lib.h"


/*----------------------------------------------------------------------
 * Definitions
 *---------------------------------------------------------------------*/

#define u32 unsigned long
#define u8 unsigned char


/*----------------------------------------------------------------------
 * Constants
 *---------------------------------------------------------------------*/

#define		AM_MASK		0x3F 
#define		IRQLVL_MASK	0x7
#define		IRQEN_MASK	0x7F


/*----------------------------------------------------------------------
 * Structure that interface the VMEchip2's LCSR 32 bits registers 
 *---------------------------------------------------------------------*/

typedef struct
{
	u32 slave_adr[2];	/*BASE + 0*/
	u32 slave_trans[2];	/*BASE + 8*/
	u32 slave_ctl;		/*BASE + 10*/
	u32 master_adr[4];	/*BASE + 14*/
	u32 master_trans4;	/*BASE + 24*/
	u32 master_adr_mod;	/*BASE + 28*/
	u32 master_ctl;		/*BASE + 2C*/
	u32 dma_ctl1;		/*BASE + 30*/
	u32 dma_ctl2;		/*BASE + 34*/
	u32 dma_local_bus;	/*BASE + 38*/
	u32 dma_vme_bus;	/*BASE + 3C*/
	u32 dma_byte_cntr;	/*BASE + 40*/
	u32 dma_table_adr;	/*BASE + 44*/
	u32 vme_it_ctl;		/*BASE + 48*/
	u32 timers;		/*BASE + 4C*/
	u32 tick_comp1;		/*BASE + 50*/
	u32 tick_cntr1;		/*BASE + 54*/
	u32 tick_comp2;		/*BASE + 58*/
	u32 tick_cntr2;		/*BASE + 5C*/
	u32 brd_ctl;		/*BASE + 60*/
	u32 prescaler;		/*BASE + 64*/
	u32 it_status;		/*BASE + 68*/
	u32 it_enable;		/*BASE + 6C*/
	u32 it_set;		/*BASE + 70*/
	u32 it_clr;		/*BASE + 74*/
	u32 it_level_brd;	/*BASE + 78*/
	u32 it_level_sig;	/*BASE + 7C*/
	u32 it_level_sw;	/*BASE + 80*/
	u32 it_level_vmeirq;	/*BASE + 84*/
	u32 vbr_ioctl;		/*BASE + 88*/
	u32 misc_ctl;		/*BASE + 8C*/
} VMEchip2;


#endif /* _VMEchip2_h */
