#include <stdio.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/time.h>
#include <unistd.h>
#include "ICV196.h"

extern int errno;

void main (unsigned int argc, char **argv)
{
        int fd, i, j;
        ICV196_arg arg;
	struct timeval before, after;
	struct timespec millisec={0, 100000};
	float elapsed;
	int action;

	if (argc > 1) {
        	fd = open (argv[1], O_RDWR, 0x666); 
		printf("opened %s , fd=%d\n",argv[1],fd);
	}
	else {
        	fd = open ("/dev/ICV196_0", O_RDWR, 0x666); 
		printf("opened /dev/ICV196_0 , fd=%d\n",fd);
	}
	if (argv < 0) exit(0);
	if (argc > 2) {
		action = RD;
	}
	else {
		action = WR;
	}

/*
 * program first 2 words as outputs
 */
	arg.op = IO_DIR;
	arg.val[0] = 0xff;
	arg.val[1] = 0x00;
	if (ioctl(fd, WR, (void*)&arg) != 0)
        {
	        printf("error detected programming direction (errno = %d) !\n",errno);
        }            
	for (;;)
	{
	switch (action) 
	{
		case (WR) :

		gettimeofday(&before, NULL);
		for (j=0; j<0x100; j++)
		{
			arg.op = DIO_WORD;
			arg.num = 0;
			arg.val[0] = j & 0x00ff;
			arg.val[1] = j & 0x00ff;
			/*arg.val[1] = (j >> 8) & 0x00ff;*/
	
			if (ioctl(fd, WR, (void*)&arg) != 0)
			{
				printf("error detected writing word (errno = %d) !\n",errno);
			}
			nanosleep(&millisec,NULL);
		}
		gettimeofday(&after, NULL);
		elapsed = after.tv_sec - before.tv_sec;
		elapsed = elapsed*1000. + (float)(after.tv_usec-before.tv_usec)/1000.;
		printf("elapsed time %6.3f ms for %d writes = %6.3f ms per call\n",
		        elapsed, 0x100, elapsed/(float)0x100);

		break;

		case (RD) :

		gettimeofday(&before, NULL);
		for (j=0; j<0x100; j++)
		{
			arg.op = DIO_WORD;
			arg.num = 0;
	
			if (ioctl(fd, RD, (void*)&arg) != 0)
			{
				printf("error detected reading word (errno = %d) !\n",errno);
			}
			printf("val 0x%02x%02x\n", arg.val[1], arg.val[0]);
			nanosleep(&millisec,NULL);
		}
		gettimeofday(&after, NULL);
		elapsed = after.tv_sec - before.tv_sec;
		elapsed = elapsed*1000. + (float)(after.tv_usec-before.tv_usec)/1000.;
		printf("elapsed time %6.3f ms for %d reads = %6.3f ms per call\n",
		        elapsed, 0x100, elapsed/(float)0x100);

		break;
	}
	}
}

