#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include "ICV196.h"


void main (void)
{
	int FD, n1=0, n2;
	ICV196_arg arg;

	FD = open ("/dev/ICV196_0", O_RDWR, 0x666);
	printf("\n\nFile Descriptor = %d", FD);

	if (FD == -1)
	{
		printf("\n\nError, unable to open the ICV196 board\n");
		exit (0);
	}

	while (n1 != 9)
	{
		printf("\n\n*** MENU 1 ***\n1. RD\n2. WR\n3. SLEEP\n9. Quit\n\nYour choise : ");
		scanf("%d",&n1);
		switch (n1)
		{
		case 1:
			printf("\n\n\t*** MENU 2 : RD ***\n\t1. DIO_BIT\n\t2. DIO_BYTE\n\t3. DIO_WORD\n\t4. DIO_ALL\n\t5. IO_DIR\n\t9. Back\n\n\tYour choise : ");
			scanf("%d",&n2);

			switch (n2)
			{
			case 1:
			{
				int i;

				arg.op = DIO_BIT;

				printf("\n\n\t\t*** MENU 3 : RD | DIO_BIT ***\n\n\t\tEnter Bit_rank (0-95) : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);

				if (!ioctl(FD, RD, (void*) &arg))
					printf("\n\n\t\t\tDone : RD | DIO_BIT | bit %d | val %d", arg.num, arg.val[0]);
				else
					printf("\n\n\t\t\tError : Check bit number and port direction");
 				break;
			}
			case 2:
			{
				int i;

				arg.op = DIO_BYTE;

				printf("\n\n\t\t*** MENU 3 : RD | DIO_BYTE ***\n\n\t\tEnter port number (0-11) : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);

				if (!ioctl(FD, RD, (void*) &arg))
					printf("\n\n\t\t\tDone : RD | DIO_BYTE | port %d | val 0x%02X", arg.num, arg.val[0]);
				else
					printf("\n\n\t\t\tError : Check port number and port direction");
 				break;
			}
			case 3:
			{
				int i;

				arg.op = DIO_WORD;

				printf("\n\n\t\t*** MENU 3 : RD | DIO_WORD ***\n\n\t\tEnter Word's low_port number (0-10) : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);

				if (!ioctl(FD, RD, (void*) &arg))
				{
					printf("\n\n\t\t\tDone : RD | DIO_WORD | word %d", arg.num); 
					printf("\n\t\t\t       (low->port %d, high->port %d) | val 0x%02X%02X", arg.num, arg.num+1, arg.val[1], arg.val[0]);
				}
				else
					printf("\n\n\t\t\tError : Check word number and ports direction");
 				break;
			}
			case 4:
			{
				int i;

				arg.op = DIO_ALL;

				printf("\n\n\t\t*** MENU 3 : RD | DIO_ALL ***");

				if (!ioctl(FD, RD, (void*) &arg))
				{
					printf("\n\n\t\t\tDone : RD | DIO_ALL | val 0x");
					for (i=0; i<12; i++)
						printf("%02X", arg.val[(MAX_PORTS-1)-i]);
				}
				else
					printf("\n\n\t\t\tError : Check ports direction : must be all input");
 				break;
			}
			case 5:
			{
				int i;

				arg.op = IO_DIR;

				printf("\n\n\t\t*** MENU 3 : RD | IO_DIR ***");

				if (!ioctl(FD, RD, (void*) &arg))
					printf("\n\n\t\t\tDone : RD | IO_DIR | val 0x%02X%02X", arg.val[1], arg.val[0]);
				else
					printf("\n\n\t\t\tError : Can't read ports direction");
 				break;
			}
			case 9:
				break;
			default:
				printf("Bad command");
				break;
			}

			break;

		case 2:
			printf("\n\n\t*** MENU 2 : WR ***\n\t1. DIO_BIT\n\t2. DIO_BYTE\n\t3. DIO_WORD\n\t4. DIO_ALL\n\t5. IO_DIR\n\t9. Back\n\n\tYour choise : ");
			scanf("%d",&n2);

			switch (n2)
			{
			case 1:
			{
				int i, j;

				arg.op = DIO_BIT;

				printf("\n\n\t\t*** MENU 3 : WR | DIO_BIT ***\n\n\t\tEnter Bit_rank (0-95) : ");
				scanf("%d", &i);
				printf("\n\t\tEnter value (0/1) : ");
				scanf("%d", &j);
				arg.num = (u8) (i & 0x00FF);
				arg.val[0] = (u8) (j & 0x00FF);

				if (!ioctl(FD, WR, (void*) &arg))
					printf("\n\n\t\t\tDone : WR | DIO_BIT | bit %d | val %d", arg.num, arg.val[0]);
				else
					printf("\n\n\t\t\tError : Check bit number and port direction");
 				break;
			}
			case 2:
			{
				int i;
				u16 j;

				arg.op = DIO_BYTE;

				printf("\n\n\t\t*** MENU 3 : WR | DIO_BYTE ***\n\n\t\tEnter port number (0-11) : ");
				scanf("%d", &i);
				printf("\n\t\tEnter value (0xii) : ");
				scanf("%hx", &j);
				arg.num = (u8) (i & 0x00FF);
				arg.val[0] = (u8) (j & 0x00FF);

				if (!ioctl(FD, WR, (void*) &arg))
					printf("\n\n\t\t\tDone : WR | DIO_BYTE | port %d | val 0x%02X", arg.num, arg.val[0]);
				else
					printf("\n\n\t\t\tError : Check port number and port direction");
 				break;
			}
			case 3:
			{
				int i;
				u16 j;

				arg.op = DIO_WORD;

				printf("\n\n\t\t*** MENU 3 : WR | DIO_WORD ***\n\n\t\tEnter word's low_port number (0-10) : ");
				scanf("%d", &i);
				printf("\n\t\tEnter word value (0xiiii) : ");
				scanf("%hx", &j);
				arg.num = (u8) (i & 0x00FF);
				arg.val[0] = (u8) (j & 0x00FF);
				arg.val[1] = (u8) ((j>>8) & 0x00FF);

				if (!ioctl(FD, WR, (void*) &arg))
				{
					printf("\n\n\t\t\tDone : WR | DIO_WORD | word %d", arg.num); 
					printf("\n\t\t\t       (low->port %d, high->port %d) | val 0x%02X%02X", arg.num, arg.num+1, arg.val[1], arg.val[0]);
				}
				else
					printf("\n\n\t\t\tError : Check port numbers and port direction");
 				break;
			}
			case 4:
			{
				u32 i;

				arg.op = DIO_ALL;

				printf("\n\n\t\t*** MENU 3 : WR | DIO_ALL ***\n\n\t\t\tEnter the firt 32 bits value (ports 3-0 / 0xiiiiiiii):\n\t\t\t");
				scanf("%lx", &i);
				arg.val[0] = (u8) (i & 0x00FF);
				arg.val[1] = (u8) ((i>>8) & 0x00FF);
				arg.val[2] = (u8) ((i>>16) & 0x00FF);
				arg.val[3] = (u8) ((i>>24) & 0x00FF);
				printf("\n\n\t\t\tEnter the second 32 bits value (ports 7-4 / 0xiiiiiiii):\n\t\t\t");
				scanf("%x", &i);
				arg.val[4] = (u8) (i & 0x00FF);
				arg.val[5] = (u8) ((i>>8) & 0x00FF);
				arg.val[6] = (u8) ((i>>16) & 0x00FF);
				arg.val[7] = (u8) ((i>>24) & 0x00FF);
				printf("\n\n\t\t\tEnter the third 32 bits value (ports 11-8 / 0xiiiiiiii):\n\t\t\t");
				scanf("%x", &i);
				arg.val[8] = (u8) (i & 0x00FF);
				arg.val[9] = (u8) ((i>>8) & 0x00FF);
				arg.val[10] = (u8) ((i>>16) & 0x00FF);
				arg.val[11] = (u8) ((i>>24) & 0x00FF);

				if (!ioctl(FD, WR, (void*) &arg))
				{
					printf("\n\n\t\t\tDone : WR | DIO_ALL | val 0x");
					for (i=0; i<12; i++)
						printf("%02X", arg.val[(MAX_PORTS-1)-i]);
				}
				else
					printf("\n\n\t\t\tError : Check ports direction : must be all input");
				break;
			}
			case 5:
			{
				u16 i;

				arg.op = IO_DIR;

				printf("\n\n\t\t*** MENU 3 : WR | IO_DIR ***\n\n\t\tEnter the mask (0->input, 1->output / 0xiii) : ");
				scanf("%hx", &i);
				arg.val[0] = (u8) (i & 0x00FF);
				arg.val[1] = (u8) ((i>>8) & 0x000F);

				if (!ioctl(FD, WR, (void*) &arg))
					printf("\n\n\t\t\tDone : WR | IO_DIR | val 0x%02X%02X", arg.val[1], arg.val[0]);
				else
					printf("\n\n\t\t\tError : Can't write ports direction");
 				break;
			}
			case 9:
				break;

			default:
				printf("Bad command");
				break;
			}

			break;

		case 3:
			printf("\n\n\t*** MENU 2 : SLEEP ***\n\t1. RISE\n\t2. FALL\n\t3. ANY\n\t4. HIGH\n\t5. LOW\n\t9. Back\n\n\tYour choise : ");
			scanf("%d",&n2);

			switch (n2)
			{
			case 1:
			{
				int i;

				arg.op = RISE;

				printf("\n\n\t\t*** MENU 3 : SLEEP | RISE ***\n\n\t\tEnter the interrupt channel number : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);
				printf("\n\t\tEnter the interrupt timeout (int): ");
				scanf("%ld", &arg.it_timeout);

				if (!ioctl(FD, SLEEP, (void*) &arg))
					printf("\n\n\t\t\tDone : SLEEP | RISE");
				else
					printf("\n\n\t\t\tError : Check channel number and group direction");
 				break;
			}

			case 2:
			{
				int i;

				arg.op = FALL;

				printf("\n\n\t\t*** MENU 3 : SLEEP | FALL ***\n\n\t\tEnter the interrupt channel number : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);
				printf("\n\t\tEnter the interrupt timeout (hex): ");
				scanf("%ld", &arg.it_timeout);

				if (!ioctl(FD, SLEEP, (void*) &arg))
					printf("\n\n\t\t\tDone : SLEEP | FALL");
				else
					printf("\n\n\t\t\tError : Check channel number and group direction");
 				break;
			}

			case 3:
			{
				int i;

				arg.op = ANY;

				printf("\n\n\t\t*** MENU 3 : SLEEP | ANY ***\n\n\t\tEnter the interrupt channel number : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);
				printf("\n\t\tEnter the interrupt timeout (hex): ");
				scanf("%ld", &arg.it_timeout);

				if (!ioctl(FD, SLEEP, (void*) &arg))
					printf("\n\n\t\t\tDone : SLEEP | ANY");
				else
					printf("\n\n\t\t\tError : Check channel number and group direction");
 				break;
			}

			case 4:
			{
				int i;

				arg.op = HIGH;

				printf("\n\n\t\t*** MENU 3 : SLEEP | HIGH ***\n\n\t\tEnter the interrupt channel number : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);
				printf("\n\t\tEnter the interrupt timeout (int): ");
				scanf("%ld", &arg.it_timeout);

				if (!ioctl(FD, SLEEP, (void*) &arg))
					printf("\n\n\t\t\tDone : SLEEP | HIGH");
				else
					printf("\n\n\t\t\tError : Check channel number and group direction");
 				break;
			}

			case 5:
			{
				int i;

				arg.op = LOW;

				printf("\n\n\t\t*** MENU 3 : SLEEP | LOW ***\n\n\t\tEnter the interrupt channel number : ");
				scanf("%d", &i);
				arg.num = (u8) (i & 0x00FF);
				printf("\n\t\tEnter the interrupt timeout (int): ");
				scanf("%ld", &arg.it_timeout);

				if (!ioctl(FD, SLEEP, (void*) &arg))
					printf("\n\n\t\t\tDone : SLEEP | LOW");
				else
					printf("\n\n\t\t\tError : Check channel number and group direction");
 				break;
			}

			case 9:
				break;

			default:
				printf("Bad command");
				break;
			}

			break;

		case 9:
			break;

		default:
			printf("Bad command\n");
			break;
		}
	}

	close (FD);
}	
